#!/usr/bin/python 
# Change notes 
# v0.1 - Initial version 
import os, sys
# Variables
channels=[]
listchannels=[]
counter=0
uninstall = 0 
# Check sys argv 
if len(sys.argv) < 2:
	print("Usage: " + sys.argv[0]+ " filename.m3u")
	print("or to uninstall the changes")
	print("Usage: " + sys.argv[0]+ " uninstall")
	sys.exit(1)
if "uninstall" in sys.argv:
	uninstall = 1 
# Clean up any existing stuff
# Bouquets
print("Removing old IPTV bouquets...")
for fname in os.listdir("/etc/enigma2/"):
	if "userbouquet.suls_iptv_" in fname:
		os.remove("/etc/enigma2/"+fname)
# Custom Channels and sources 
print("Removing IPTV custom channels...")
for fname in os.listdir("/etc/epgimport/"):
	if "suls_iptv_" in fname:
		os.remove("/etc/epgimport/"+fname)	
# bouquets.tv
print("Removing IPTV bouquets from bouquets.tv...")
os.rename("/etc/enigma2/bouquets.tv","/etc/enigma2/bouquets.tv.bak")
tvfile = open("/etc/enigma2/bouquets.tv","w+")
bakfile = open("/etc/enigma2/bouquets.tv.bak")
for line in bakfile:
	if ".suls_iptv_" not in line:
		tvfile.write(line)
bakfile.close()
tvfile.close() 
# Exit if we are only cleaning up 
if uninstall == 1:
	print("Uninstall complete, exiting...")
	sys.exit(1) 
# Read M3u file and create stuff
print("Reading m3u file ...")
with open (sys.argv[1], "r") as myfile:
	for line in myfile:
		if 'EXTM3U' in line: # First line we are not interested 
			a = "we dont care"
		elif 'EXTINF:' in line: # Info line - work out group and output the line
			outfile = "output/IPTV-"+line.split('"')[7].replace("/"," ")+".m3u"
			channels = [line.split('"')[7],line.split(',')[1].strip()]
		elif 'http:' in line:
			channels.append(line.strip())
			listchannels.append(channels)
			counter = counter + 1
# Clean up VOD to single Bouquet 
for x in listchannels:
	if x[2].endswith(('.mp4','mkv','.avi',"mpg")):
		x[0] = "VOD"
# Sort the list 
listchannels.sort()
# Add Service references 
num =1 
for x in listchannels:
	x.append("1:0:1:"+str(num)+":0:0:0:0:0:0")
	num += 1 
# Create Bouquets 
print("Creating bouquets...")
group="" 
for x in listchannels:
	if x[0] == group:
		#Append to file 
		file = open("/etc/enigma2/userbouquet.suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".tv","a")
		file.write("#SERVICE "+x[3]+":"+x[2].replace(":","%3a")+":"+x[1]+"\n")
		file.write("#DESCRIPTION "+x[1]+"\n")
		file.close()
	else:
		#create file 
		file = open("/etc/enigma2/userbouquet.suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".tv","w+")
		file.write("#NAME IPTV - "+x[0].replace("/"," ")+"\n")
		file.write("#SERVICE "+x[3]+":"+x[2].replace(":","%3a")+":"+x[1]+"\n")
		file.write("#DESCRIPTION "+x[1]+"\n")
		file.close()
		# Add to main bouquets files 
		file = open("/etc/enigma2/bouquets.tv","a")
		file.write("#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET \"userbouquet.suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".tv\" ORDER BY bouquet\n")
		file.close()
		# Update current group		
		group = x[0]
# Create Custom Channels
print("Creating custom channels...")
group="" 
for x in listchannels:
	if x[0] == group:
		#Append to file 
		file = open("/etc/epgimport/suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".channels.xml","a")
		file.write("<channel id=\""+x[1].replace(' ','').replace("FHD","").replace("HD","").replace("SD","")+".uk"+"\">"+x[3]+":http%3a//example.m3u8</channel> <!-- "+x[1]+" -->\n")
		file.close()
	else:
		# Close tag on last file if relevant 
		if group !="":
			file = open("/etc/epgimport/suls_iptv_"+group.replace(" ","_").replace("/","_")+".channels.xml","a")
			file.write("</channels>\n")
			file.close()
		#create channels file 
		file = open("/etc/epgimport/suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".channels.xml","w+")
		file.write("<channels>\n")
		file.write("<channel id=\""+x[1].replace(' ','').replace("FHD","").replace("HD","").replace("SD","")+".uk"+"\">"+x[3]+":http%3a//example.m3u8</channel> <!-- "+x[1]+" -->\n")
		file.close()
		#create custom sources file 
		file = open("/etc/epgimport/suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".sources.xml","w+")
		file.write("<sources><source type=\"gen_xmltv\" channels=\"/etc/epgimport/suls_iptv_"+x[0].replace(" ","_").replace("/","_")+".channels.xml\">\n")
		file.write("<description> IPTV - "+x[0].replace("/"," ")+"</description>\n")
		file.write("<url>http://www.xmltvepg.nl/rytecxmltv-UK.gz</url>\n")
		file.write("<url>http://rytecepg.ipservers.eu/epg_data/rytecxmltv-UK.gz</url>\n")
		file.write("<url>http://rytecepg.wanwizard.eu/rytecxmltv-UK.gz</url>\n")
		file.write("<url>http://91.121.106.172/~rytecepg/epg_data/rytecxmltv-UK.gz</url>\n")
		file.write("<url>http://www.vuplus-community.net/rytec/rytecxmltv-UK.gz</url>\n")
		file.write("</source></sources>\n")
		file.close()
		# Update current group		
		group = x[0]
print("********************************")		
print("Engima2 IPTV bouquets created ! ")
print("********************************")		
print("Please reboot your box, then open epg-import plugin.. ")
print("select sources and enable the new IPTV sources for UK IPTV channels if you want EPG data")





